variables:
  DOCKER_HOST: tcp://docker:2375
  DOCKER_DRIVER: overlay2
  DOCKER_TLS_CERTDIR: ""

services:
  - docker:19.03.12-dind

cache:
  paths:
    - target/

stages:
  - test
  - package
  - dockerhub
  - deploy
  - cleanup
  - helm

test:
  image: maven:3.3-jdk-8
  stage: test
  script:
    - mvn verify
  tags:
    - omega

package:
  image: maven:3.3-jdk-8
  stage: package
  script:
    - mvn clean package
  tags:
    - omega
  artifacts:
    paths:
      - target/*.jar

dockerhub:
  image: docker:19.03.12
  before_script:
    - apk add --update && apk add git
    - export DATE_TAG=$(git log -n1 --date=format:'%y%m%d-' --format=%cd)
    - docker login -u $DOCKERHUB_USER -p $DOCKERHUB_PASSWORD $DOCKERHUB_REGISTRY
  stage: dockerhub
  script:
    - docker build -t $DOCKERHUB_USER/maven_app:$DATE_TAG$CI_COMMIT_SHORT_SHA $CI_PROJECT_DIR --build-arg FOO=$DATE_TAG$CI_COMMIT_SHORT_SHA
    - docker push $DOCKERHUB_USER/maven_app:$DATE_TAG$CI_COMMIT_SHORT_SHA
  tags:
    - omega


k8s_deploy:
  before_script:
    - echo $K8S_CONFIG | base64 -d > /tmp/k8s.conf
    - export KUBECONFIG=/tmp/k8s.conf
  stage: deploy
  script:
    - kubectl create namespace $CI_COMMIT_REF_NAME 
    - kubectl config set-context --current --namespace=$CI_COMMIT_REF_NAME
    - openssl req -x509 -out app.omega.com.crt -keyout app.omega.com.key -newkey rsa:2048 -nodes -sha256 -subj '/CN=*.omega.com' -extensions EXT -config <( printf "[dn]\nCN=*.omega.com\n[req]\ndistinguished_name = dn\n[EXT]\nsubjectAltName=DNS:*.omega.com\nkeyUsage=digitalSignature\nextendedKeyUsage=serverAuth")
    - kubectl create secret generic mysql-sec --from-literal=ROOT_PASSWORD=$PASS --from-literal=USERNAME=$USER --from-literal=DATABASE=$DB --from-literal=PASSWORD=$PASS
    - kubectl create secret tls webapp-tls --key app.omega.com.key --cert app.omega.com.crt
    - cd k8s/
    - kustomize edit set image omegazyadav/maven_app:$(git log -n1 --date=format:'%y%m%d-' --format=%cd%h)
    - kubectl apply -k .
  tags:
    - shell 


k8s_cleanup:
  before_script:
    - echo $K8S_CONFIG | base64 -d > /tmp/k8s.conf
    - export KUBECONFIG=/tmp/k8s.conf
    - kubectl config set-context --current --namespace=$CI_COMMIT_REF_NAME
  stage: cleanup
  script:
    - kubectl delete secret mysql-sec webapp-tls 
    - kubectl delete -k k8s/ 
    - kubectl delete namespace $CI_COMMIT_REF_NAME
  tags:
    - shell 


helm:
  before_script:
    - echo $K8S_CONFIG | base64 -d > /tmp/k8s.conf
    - export KUBECONFIG=/tmp/k8s.conf
  stage: helm
  script:
    - helm upgrade --install webapp ./webapp_chart
  tags:
    - shell 
    
